:: Notepad Replacer
@ECHO OFF
SETLOCAL ENABLEEXTENSIONS
SETLOCAL ENABLEDELAYEDEXPANSION

::
:: Get Windows Version
::
SET WinVer=
ver | findstr /c:" 5.1" >nul && SET WinVer=5.1
ver | findstr /c:" 5.2" >nul && SET WinVer=5.2
ver | findstr /c:" 6.0" >nul && SET WinVer=6.0
ver | findstr /c:" 6.1" >nul && SET WinVer=6.1

ECHO.
ECHO.Notepad Replacer              By Paulo Santos
ECHO.=============================================
ECHO.Created in 2009.12.30             WinVer: %WinVer%
ECHO.

::
:: Check if the Notepad++ and Notepad Launcher are present and accounted for
::
IF EXIST "%~dp0Notepad++.exe" IF EXIST "%~dp0Notepad.exe" GOTO :ReplaceNotepad

ECHO.The Notepad++ or Notepad launcher were not found.
ECHO.Please check if the files exists before running this script.
EXIT /B 1

:ReplaceNotepad
::
:: Check if the running user is the administrator
::
SET "RunAsUser=Administrator"
IF %WinVer% GEQ 6.0 (
  ECHO. Current User : %USERNAME%
  ECHO. Desired User : %RunAsUser%
  if  /i "%USERNAME%" NEQ "%RunAsUser%" (
      ECHO.
      ECHO.Due to some access restrictions this script must be run with
      ECHO.Administrator's right.
      ECHO.
      ECHO.When you type the administrator's password below another
      ECHO.console window will be open that will continue the Notepad
      ECHO.replacement process.
      ECHO.
      RUNAS /user:%RunAsUser% "cmd /k \"%~f0\" "
      GOTO:EOF
  )
)

CALL :CheckAndReplace "%SystemRoot%\ServicePackFiles\i386"
IF ERRORLEVEL 2 ECHO.Impossible to continue! & GOTO :EOF
IF ERRORLEVEL 1 ECHO.Unable to copy file to folder
ECHO.
CALL :CheckAndReplace "%SystemRoot%\System32\dllCache"
IF ERRORLEVEL 2 ECHO.Impossible to continue! & GOTO :EOF
IF ERRORLEVEL 1 ECHO.Unable to copy file to folder
ECHO.
CALL :CheckAndReplace "%SystemRoot%\System32"
IF ERRORLEVEL 2 ECHO.Impossible to continue! & GOTO :EOF
IF ERRORLEVEL 1 ECHO.Unable to copy file to folder
ECHO.
CALL :CheckAndReplace "%SystemRoot%"
IF ERRORLEVEL 2 ECHO.Impossible to continue! & GOTO :EOF
IF ERRORLEVEL 1 ECHO.Unable to copy file to folder
ECHO.

ECHO.Setting Registry Value...
set np=%~dp0
set np=%np:~0,-1%
CALL :SetRegValue "HKLM\SOFTWARE\Notepad++" "@" "%np%"
IF ERRORLEVEL 1 (
ECHO.Error while setting the registry value.
) ELSE (
ECHO.Notepad replaced successfully.
)

EXIT /B 0

:CheckAndReplace
::
:: Check if the folder exists
::
ECHO.Checking "%~1" ...
IF EXIST "%~1" (
  ECHO.Folder Exists.
  ECHO.Checking Notepad.old ...
  IF NOT EXIST "%~1\Notepad.old" (
    ECHO.Notepad.old doesn't exist.
    ECHO.Checking Notepad.exe ...
    IF EXIST "%~1\Notepad.exe" (
      ECHO.Renaming Notepad.exe to Notepad.old
      REN "%~1\Notepad.exe" *.old
      IF ERRORLEVEL 1 (
        ECHO.Unable to rename Notepad.exe to Notepad.old
        IF %WinVer% GEQ 6.0 (
          CALL :TakeOwnership "%~1"
          IF ERRORLEVEL 1 (
            ECHO.Unable to rename Notepad.exe to Notepad.old
            ECHO.Please, try to replace Notepad.exe manually.
            EXIT /B 2
          )
        ) ELSE (
          ECHO.Please, try to replace Notepad.exe manually.
          EXIT /B 2
        )
      )
    )
    ECHO. Replacing Notepad with Notepad++
    COPY "%~dp0Notepad.exe" "%~1\"
    IF ERRORLEVEL 1 EXIT /B 1
  )
) ELSE ECHO.Folder does not exist.
EXIT /B 0

:SetRegValue Key Value Data Type -- sets a registry value
::                               -- Key    [in]  - registry key
::                               -- Value  [in]  - registry value
::                               -- Data   [in]  - (optional) data
::                               -- Type   [in]  - (optional) data type, i.e.: REG_SZ, REG_MULTI_SZ, REG_DWORD_BIG_ENDIAN, REG_DWORD, REG_BINARY, REG_DWORD_LITTLE_ENDIAN, REG_NONE, REG_EXPAND_SZ
:$created 20060101 :$changed 20080219 :$categories Registry
:$source http://www.dostips.com
SETLOCAL
set Key=%~1
set Val=%~2
set Data=%~3
set Type=%~4
if "%~2"=="@" set Val=/ve
if "%~2" NEQ "" if "%~2" NEQ "@" set Val=/v "%Val%"
if "%Data%" NEQ "" set Data=/f /d "%Data%"
if "%Type%" NEQ "" set Type=/t %Type%
echo.Y|reg add "%Key%" %Val% %Type% %Data% >nul
if errorlevel 1 ENDLOCAL & EXIT /b 1
ENDLOCAL
EXIT /b 0

:TakeOwnership
ECHO.Attempting to take ownership of the file...
TAKEOWN /F "%~1\Notepad.exe"
IF ERRORLEVEL 1 EXIT /B 1

ECHO.Granting access to the file...
ICACLS "%~1\Notepad.exe" /grant %USERNAME%:(f)
IF ERRORLEVEL 1 EXIT /B 1

ECHO.Renaming Notepad.exe to Notepad.old
REN "%~1\Notepad.exe" *.old
IF ERRORLEVEL 1 EXIT /B 1

EXIT /B 0